import { TdChartOptionsService, TdCoordinateSystem, TdMarkPointSymbol, ITdMarkPoint, ITdItemStyle, ITdLabel, ITdEmphasis, TdSeriesLayoutBy, ITdMarkLine, ITdMarkArea, TdSeriesComponent, ITdSeries } from '@covalent/echarts/base';
export interface ITdScatterSeries extends ITdSeries<'scatter'> {
    coordinateSystem?: TdCoordinateSystem;
    xAxisIndex?: number;
    yAxisIndex?: number;
    polarIndex?: number;
    geoIndex?: number;
    calendarIndex?: number;
    hoverAnimation?: boolean;
    legendHoverLink?: boolean;
    symbol?: TdMarkPointSymbol | string;
    symbolSize?: number | any[] | Function;
    symbolRotate?: number;
    symbolKeepAspect?: boolean;
    symbolOffset?: any[];
    large?: boolean;
    largeThreshold?: number;
    cursor?: string;
    connectNulls?: boolean;
    clipOverflow?: boolean;
    step?: boolean;
    label?: ITdLabel;
    itemStyle?: any;
    emphasis?: ITdEmphasis;
    progressive?: number;
    progressiveThreshold?: number;
    dimensions?: any[];
    encode?: any;
    seriesLayoutBy?: TdSeriesLayoutBy;
    datasetIndex?: number;
    data?: any[];
    markPoint?: ITdMarkPoint;
    markLine?: ITdMarkLine;
    markArea?: ITdMarkArea;
    zlevel?: number;
    z?: number;
    silent?: boolean;
}
export declare class TdChartSeriesScatterComponent extends TdSeriesComponent<'scatter'> implements ITdScatterSeries {
    coordinateSystem: TdCoordinateSystem;
    xAxisIndex: number;
    yAxisIndex: number;
    polarIndex: number;
    geoIndex: number;
    calendarIndex: number;
    hoverAnimation: boolean;
    legendHoverLink: boolean;
    symbol: TdMarkPointSymbol | string;
    symbolSize: number | any[] | Function;
    symbolRotate: number;
    symbolKeepAspect: boolean;
    symbolOffset: any[];
    large: boolean;
    largeThreshold: number;
    cursor: string;
    label: ITdLabel;
    itemStyle: ITdItemStyle;
    emphasis: ITdEmphasis;
    progressive: number;
    progressiveThreshold: number;
    dimensions: any[];
    encode: any;
    seriesLayoutBy: TdSeriesLayoutBy;
    datasetIndex: number;
    markPoint: ITdMarkPoint;
    markLine: ITdMarkLine;
    markArea: ITdMarkArea;
    zlevel: number;
    z: number;
    silent: boolean;
    constructor(_optionsService: TdChartOptionsService);
    getConfig(): any;
}
